/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         gestruparse
#define yylex           gestrulex
#define yyerror         gestruerror
#define yydebug         gestrudebug
#define yynerrs         gestrunerrs
#define yylval          gestrulval
#define yychar          gestruchar

/* First part of user prologue.  */
#line 7 "gestru.y"

/*force le debugging du YACC                    */
#define lint    1
#ifdef	DEBUG
#define YYDEBUG 1
#endif

#include	<string.h>
#include	<stdio.h>
#include	<setjmp.h>
#include	<syslog.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<time.h>
#include	<ctype.h>

#include	"lowtyp.h"
#include	"utlvec.h"
#include	"bascnv.h"
#include	"subclm.h"
#include	"unieml.h"
#include	"gestru.h"

int yyparse();		/*syntax parser		*/
static int yylex();	/*lexical parser	*/

/*preamble static function declaration		*/
static void yyerror(char *);

static STRMTY **ystrms;	/*yacc stream info	*/
static int itsok;	/*parsing status	*/
static jmp_buf manystop;/*YACC fully lost	*/
static int cptstop=0;	/*stop received counting*/
static char *ykeyword;	/*ref to current kword	*/

static char **lines;	/*data-header pointer	*/
static int numline;	/*next char header line	*/
static int numrow;	/*next char header row	*/
static int curline;	/*cur char header line	*/
static u_int currow;	/*cur char header row	*/
static int nbrerr;	/*number of error so far*/
static int lastcode;	/*last code retreived	*/

#define	MXSTR	60	/*max line size in debug*/
#define STRIPV6	"ipv6"	/*Ipv6 ip marker	*/
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate  DLGTYPstructure	*/
/*						*/
/************************************************/
static DLGTYP **dupdlgs(DLGTYP **dlgs)

{
DLGTYP **ndlgs;

ndlgs=(DLGTYP **)0;
if (dlgs!=(DLGTYP **)0) {
  DLGTYP **ptr;

  for (ptr=dlgs;(*ptr)!=(DLGTYP *)0;ptr++) {
    DLGTYP *ndlg;

    if ((ndlg=tru_dupdlg(*ptr))!=(DLGTYP *)0) 
      ndlgs=(DLGTYP **)vec_addlstlst((void **)ndlgs,(void *)ndlg);
    }
  }
return ndlgs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free memory used by DLGTYP	*/
/*	structure.				*/
/*						*/
/************************************************/
static DLGTYP **freedlgs(DLGTYP **dlgs)

{
if (dlgs!=(DLGTYP **)0) {
  int i;

  for (i=0;dlgs[i]!=(DLGTYP *)0;i++) 
    dlgs[i]=tru_freedlg(dlgs[i]);
  (void) free(dlgs);
  dlgs=(DLGTYP **)0;
  }
return dlgs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free memory used by streams*/
/*	structure.				*/
/*						*/
/************************************************/
static STRMTY **freestreams(STRMTY **strms)

{
if (strms!=(STRMTY **)0) {
  int i;

  for (i=0;strms[i]!=(STRMTY *)0;i++) 
    strms[i]=tru_freestrm(strms[i]);
  (void) free(strms);
  strms=(STRMTY **)0; 
  }
return strms;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get the next character from*/
/*	the data-header				*/
/*						*/
/************************************************/
static char getnextchar()

{
int c;

c=EOF;
if (lines[numline]!=(char *)0) {
  curline=numline;
  currow=numrow;
  if ((numrow==0)&&(debug>0)) {
    char *addstr;

    addstr="";
    if (strlen(lines[numline])>MXSTR)
      addstr="...";
    (void) clm_alert(9,"%6d line=<%.*s%s>",numline+1,MXSTR,lines[numline],addstr);
    }
  c=(int)lines[numline][numrow];
  if (c=='\000') {
    c=' ';
    numrow=0;
    numline++;
    }
  else
    numrow++;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip all blank character	*/
/*						*/
/************************************************/
static int skipblank()

{
int c;

c=EOF;
do {
  c=getnextchar();
  }
while (isblank(c)!=false);
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to make a ip/maks string	*/
/*						*/
/************************************************/
static STRMTY *mkipmask(char *ip,int mask,int limit)

{
STRMTY *strm;

strm=(STRMTY *)0;
if (mask>limit) {
  char *trbl;

  (void) asprintf(&trbl,"Mask value unexpected (above %d)",limit);
  (void) yyerror(trbl);
  (void) free(trbl);
  mask=limit;
  }
if (ip==(char *)0)
  (void) yyerror("IP number missing");
else {
  strm=(STRMTY *)calloc(1,sizeof(STRMTY)); 
  strm->mask=mask;
  strm->ip=ip;
  }
return strm;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to add a stream component to	*/
/*	the streamlist list.			*/
/*						*/
/************************************************/
static STRMTY **addstream(STRMTY **streams,STRMTY *stream)

{
if (stream!=(STRMTY *)0) {
  streams=(STRMTY **)vec_addlstlst((void **)streams,(void *)stream);
  }
return streams;
}
/************************************************/
/************************************************/

#line 302 "gestru.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int gestrudebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    STOP = 258,                    /* STOP  */
    CRLF = 259,                    /* CRLF  */
    PLUS = 260,                    /* PLUS  */
    MINUS = 261,                   /* MINUS  */
    EQUAL = 262,                   /* EQUAL  */
    COMMA = 263,                   /* COMMA  */
    SEMICOL = 264,                 /* SEMICOL  */
    SLASH = 265,                   /* SLASH  */
    COLON = 266,                   /* COLON  */
    DOT = 267,                     /* DOT  */
    PARLEFT = 268,                 /* PARLEFT  */
    PARRIGHT = 269,                /* PARRIGHT  */
    CURLEFT = 270,                 /* CURLEFT  */
    CURIGHT = 271,                 /* CURIGHT  */
    BRKLEFT = 272,                 /* BRKLEFT  */
    BRKRIGHT = 273,                /* BRKRIGHT  */
    PUNCT = 274,                   /* PUNCT  */
    FROM = 275,                    /* FROM  */
    BAN = 276,                     /* BAN  */
    STD = 277,                     /* STD  */
    STATUS = 278,                  /* STATUS  */
    BY = 279,                      /* BY  */
    JAN = 280,                     /* JAN  */
    FEB = 281,                     /* FEB  */
    MAR = 282,                     /* MAR  */
    APR = 283,                     /* APR  */
    MAY = 284,                     /* MAY  */
    JUN = 285,                     /* JUN  */
    JUL = 286,                     /* JUL  */
    AUG = 287,                     /* AUG  */
    SEP = 288,                     /* SEP  */
    OCT = 289,                     /* OCT  */
    NOV = 290,                     /* NOV  */
    DEC = 291,                     /* DEC  */
    MON = 292,                     /* MON  */
    TUE = 293,                     /* TUE  */
    WED = 294,                     /* WED  */
    THU = 295,                     /* THU  */
    FRI = 296,                     /* FRI  */
    SAT = 297,                     /* SAT  */
    SUN = 298,                     /* SUN  */
    WORD = 299,                    /* WORD  */
    INTEGER = 300,                 /* INTEGER  */
    HEXA = 301,                    /* HEXA  */
    STRING = 302,                  /* STRING  */
    IPV6 = 303                     /* IPV6  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 231 "gestru.y"

	STRMTY **strms;	/*full streams parsed	*/
	STRMTY *strm;	/*one trust data stream	*/
	DLGTYP *dlg;	/*data stream info	*/
	DLGTYP **dlgs;	/*data stream infos	*/
	long time;	/*time value as a long	*/
	char *strtime;	/*time as a str(long)	*/
	char *string;	/*the info is a string	*/
	char punct;	/*one char only		*/
	long integer;	/*the value is integer	*/
	char *word;	/*the info is a word	*/
	

#line 411 "gestru.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE gestrulval;


int gestruparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_STOP = 3,                       /* STOP  */
  YYSYMBOL_CRLF = 4,                       /* CRLF  */
  YYSYMBOL_PLUS = 5,                       /* PLUS  */
  YYSYMBOL_MINUS = 6,                      /* MINUS  */
  YYSYMBOL_EQUAL = 7,                      /* EQUAL  */
  YYSYMBOL_COMMA = 8,                      /* COMMA  */
  YYSYMBOL_SEMICOL = 9,                    /* SEMICOL  */
  YYSYMBOL_SLASH = 10,                     /* SLASH  */
  YYSYMBOL_COLON = 11,                     /* COLON  */
  YYSYMBOL_DOT = 12,                       /* DOT  */
  YYSYMBOL_PARLEFT = 13,                   /* PARLEFT  */
  YYSYMBOL_PARRIGHT = 14,                  /* PARRIGHT  */
  YYSYMBOL_CURLEFT = 15,                   /* CURLEFT  */
  YYSYMBOL_CURIGHT = 16,                   /* CURIGHT  */
  YYSYMBOL_BRKLEFT = 17,                   /* BRKLEFT  */
  YYSYMBOL_BRKRIGHT = 18,                  /* BRKRIGHT  */
  YYSYMBOL_PUNCT = 19,                     /* PUNCT  */
  YYSYMBOL_FROM = 20,                      /* FROM  */
  YYSYMBOL_BAN = 21,                       /* BAN  */
  YYSYMBOL_STD = 22,                       /* STD  */
  YYSYMBOL_STATUS = 23,                    /* STATUS  */
  YYSYMBOL_BY = 24,                        /* BY  */
  YYSYMBOL_JAN = 25,                       /* JAN  */
  YYSYMBOL_FEB = 26,                       /* FEB  */
  YYSYMBOL_MAR = 27,                       /* MAR  */
  YYSYMBOL_APR = 28,                       /* APR  */
  YYSYMBOL_MAY = 29,                       /* MAY  */
  YYSYMBOL_JUN = 30,                       /* JUN  */
  YYSYMBOL_JUL = 31,                       /* JUL  */
  YYSYMBOL_AUG = 32,                       /* AUG  */
  YYSYMBOL_SEP = 33,                       /* SEP  */
  YYSYMBOL_OCT = 34,                       /* OCT  */
  YYSYMBOL_NOV = 35,                       /* NOV  */
  YYSYMBOL_DEC = 36,                       /* DEC  */
  YYSYMBOL_MON = 37,                       /* MON  */
  YYSYMBOL_TUE = 38,                       /* TUE  */
  YYSYMBOL_WED = 39,                       /* WED  */
  YYSYMBOL_THU = 40,                       /* THU  */
  YYSYMBOL_FRI = 41,                       /* FRI  */
  YYSYMBOL_SAT = 42,                       /* SAT  */
  YYSYMBOL_SUN = 43,                       /* SUN  */
  YYSYMBOL_WORD = 44,                      /* WORD  */
  YYSYMBOL_INTEGER = 45,                   /* INTEGER  */
  YYSYMBOL_HEXA = 46,                      /* HEXA  */
  YYSYMBOL_STRING = 47,                    /* STRING  */
  YYSYMBOL_IPV6 = 48,                      /* IPV6  */
  YYSYMBOL_YYACCEPT = 49,                  /* $accept  */
  YYSYMBOL_dlgs = 50,                      /* dlgs  */
  YYSYMBOL_streams = 51,                   /* streams  */
  YYSYMBOL_stream = 52,                    /* stream  */
  YYSYMBOL_network = 53,                   /* network  */
  YYSYMBOL_infos = 54,                     /* infos  */
  YYSYMBOL_info = 55,                      /* info  */
  YYSYMBOL_capinfo = 56,                   /* capinfo  */
  YYSYMBOL_data = 57,                      /* data  */
  YYSYMBOL_from = 58,                      /* from  */
  YYSYMBOL_ip = 59,                        /* ip  */
  YYSYMBOL_ipv4 = 60,                      /* ipv4  */
  YYSYMBOL_ipv6 = 61,                      /* ipv6  */
  YYSYMBOL_numipv6 = 62,                   /* numipv6  */
  YYSYMBOL_pureipv6 = 63,                  /* pureipv6  */
  YYSYMBOL_status = 64,                    /* status  */
  YYSYMBOL_origine = 65,                   /* origine  */
  YYSYMBOL_domains = 66,                   /* domains  */
  YYSYMBOL_datetime = 67,                  /* datetime  */
  YYSYMBOL_cachet = 68,                    /* cachet  */
  YYSYMBOL_date = 69,                      /* date  */
  YYSYMBOL_months = 70,                    /* months  */
  YYSYMBOL_time = 71,                      /* time  */
  YYSYMBOL_hours = 72,                     /* hours  */
  YYSYMBOL_hour = 73,                      /* hour  */
  YYSYMBOL_sixty = 74,                     /* sixty  */
  YYSYMBOL_zone = 75,                      /* zone  */
  YYSYMBOL_byte = 76,                      /* byte  */
  YYSYMBOL_hexa = 77,                      /* hexa  */
  YYSYMBOL_days = 78,                      /* days  */
  YYSYMBOL_sign = 79,                      /* sign  */
  YYSYMBOL_optime = 80,                    /* optime  */
  YYSYMBOL_comments = 81,                  /* comments  */
  YYSYMBOL_comment = 82,                   /* comment  */
  YYSYMBOL_word = 83,                      /* word  */
  YYSYMBOL_keyword = 84                    /* keyword  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  17
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   218

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  49
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  36
/* YYNRULES -- Number of rules.  */
#define YYNRULES  113
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  163

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   303


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   306,   306,   318,   326,   330,   336,   344,   359,   366,
     370,   377,   382,   389,   395,   401,   417,   421,   427,   439,
     445,   449,   455,   462,   470,   480,   484,   490,   496,   504,
     508,   516,   520,   524,   531,   537,   542,   548,   552,   558,
     566,   570,   576,   581,   587,   599,   605,   609,   613,   617,
     621,   625,   629,   633,   637,   641,   645,   649,   653,   659,
     663,   667,   673,   677,   683,   693,   703,   708,   747,   757,
     766,   777,   781,   785,   789,   793,   797,   801,   807,   811,
     815,   821,   822,   826,   827,   830,   837,   841,   845,   849,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "STOP", "CRLF", "PLUS",
  "MINUS", "EQUAL", "COMMA", "SEMICOL", "SLASH", "COLON", "DOT", "PARLEFT",
  "PARRIGHT", "CURLEFT", "CURIGHT", "BRKLEFT", "BRKRIGHT", "PUNCT", "FROM",
  "BAN", "STD", "STATUS", "BY", "JAN", "FEB", "MAR", "APR", "MAY", "JUN",
  "JUL", "AUG", "SEP", "OCT", "NOV", "DEC", "MON", "TUE", "WED", "THU",
  "FRI", "SAT", "SUN", "WORD", "INTEGER", "HEXA", "STRING", "IPV6",
  "$accept", "dlgs", "streams", "stream", "network", "infos", "info",
  "capinfo", "data", "from", "ip", "ipv4", "ipv6", "numipv6", "pureipv6",
  "status", "origine", "domains", "datetime", "cachet", "date", "months",
  "time", "hours", "hour", "sixty", "zone", "byte", "hexa", "days", "sign",
  "optime", "comments", "comment", "word", "keyword", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-43)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-69)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      11,    -5,     2,   -43,    -2,    18,     7,   -43,    49,     6,
      10,   -43,    55,    15,   -43,    68,    29,   -43,   -43,    73,
     -43,    75,     3,   -43,   -43,   -43,   -43,   -43,   -43,   -43,
     103,    72,   -43,   -43,    71,    70,   -43,    16,    74,    53,
      81,    51,    96,   -43,   -43,   -43,   -43,   -43,   -43,   -43,
     -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,
     -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,
     -43,   -43,   -43,   -43,   -43,   -43,   -43,     5,   -43,   -43,
     -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,   -43,
     -43,   -43,   -43,    97,    82,   -43,   -43,   -43,    62,    57,
     111,   -43,   -43,   -43,   -43,    59,   107,   -43,    98,     9,
     -43,   -43,    60,   -43,   -43,   -43,   132,   -43,   155,   128,
     155,   -43,   -43,   134,    82,   -43,   -43,   -43,   -43,   -43,
     -43,   -43,   157,   160,   -43,   -43,   168,    96,   -43,    22,
     -43,   -43,    -3,   -43,   193,   155,   -43,    29,   194,   187,
     -43,   -43,   -43,   157,   126,   -43,   -43,    96,   -43,   -43,
     -43,   -43,   -43
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,    69,    70,     0,     0,     0,     4,     0,     0,
       0,    23,    25,     0,    29,     0,     0,     1,     6,     0,
       5,    45,     0,    72,    73,    74,    75,    76,    77,    71,
       0,     0,    11,    13,     0,     0,    41,    43,     0,     0,
       0,     0,     0,     3,    69,    24,     2,     8,    36,    94,
      92,    90,    91,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    95,    96,    97,    98,    99,
     100,   101,    89,    86,    87,    93,    19,     0,    37,    88,
      58,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,     0,     0,     7,    45,    14,     0,     0,
      79,    78,    67,    64,    42,    60,     0,    61,     0,     0,
       9,    10,     0,    28,    30,    68,     0,    35,     0,     0,
       0,    44,    12,     0,     0,    15,    33,    31,    32,    18,
      80,    59,     0,    82,    40,    27,    26,     0,    39,     0,
      38,    17,     0,    65,    63,     0,    66,     0,     0,     0,
      20,    21,    16,     0,     0,    83,    85,     0,    34,    62,
      81,    84,    22
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -43,   -43,   -43,   201,   -43,    84,   115,   -43,   176,   -43,
     -43,   -39,    76,   195,   100,   -43,   -43,   -43,   179,   105,
     -43,   -43,   -43,   -43,   -43,    63,   112,   -42,   -40,   -43,
     -43,   -43,   -43,    64,   -19,   -43
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     5,     6,     7,     8,    31,    32,   125,    33,    34,
     149,     9,    10,    11,    12,   129,    76,    77,    35,    36,
      37,    93,   104,   105,   106,   144,   107,    13,    14,    38,
     108,   146,   154,   155,   156,    79
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     116,   114,   113,    78,    48,    94,   117,    15,    18,    16,
      96,   118,     1,   152,   -68,   119,    39,   120,    17,    19,
      40,   100,   101,    49,    50,    51,    52,    42,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      21,    75,     2,     3,    30,     4,     2,     3,   126,     4,
     102,   103,   112,   123,   100,   101,    41,     2,     3,    22,
       4,    43,    96,   135,    44,     3,    46,   124,   127,   128,
      94,    95,   109,    96,    47,    99,    23,    24,    25,    26,
      27,    28,    29,    99,    30,   148,     2,     3,   110,   138,
     150,   140,    22,   102,    80,     2,     3,   114,    23,    24,
      25,    26,    27,    28,    29,   162,    30,   130,   132,    23,
      24,    25,    26,    27,    28,    29,   111,    30,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
     160,   115,   121,   133,   137,   139,    49,    50,    51,    52,
     141,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,   145,    75,    49,    50,    51,    52,   147,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,   143,    75,   153,   158,   157,    20,   142,   122,
      97,    45,   136,    98,   134,   151,   159,   131,   161
};

static const yytype_uint8 yycheck[] =
{
      42,    41,    41,    22,     1,     8,     1,    12,     1,    11,
       1,     6,     1,    16,    12,    10,    10,    12,     0,    12,
      10,     5,     6,    20,    21,    22,    23,    12,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
       1,    48,    45,    46,    45,    48,    45,    46,     1,    48,
      44,    45,    11,     1,     5,     6,    11,    45,    46,    20,
      48,     3,     1,   112,    45,    46,     3,    15,    21,    22,
       8,     9,     8,     1,     9,    23,    37,    38,    39,    40,
      41,    42,    43,    23,    45,   137,    45,    46,    45,   118,
     139,   120,    20,    44,     1,    45,    46,   147,    37,    38,
      39,    40,    41,    42,    43,   157,    45,     6,    11,    37,
      38,    39,    40,    41,    42,    43,    45,    45,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      14,    45,    45,    45,    12,    17,    20,    21,    22,    23,
      16,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    13,    48,    20,    21,    22,    23,    11,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    45,    48,    11,    18,    12,     6,   124,    94,
      34,    16,   112,    34,   109,   139,   153,   105,   154
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     1,    45,    46,    48,    50,    51,    52,    53,    60,
      61,    62,    63,    76,    77,    12,    11,     0,     1,    12,
      52,     1,    20,    37,    38,    39,    40,    41,    42,    43,
      45,    54,    55,    57,    58,    67,    68,    69,    78,    10,
      10,    11,    12,     3,    45,    62,     3,     9,     1,    20,
      21,    22,    23,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    48,    65,    66,    83,    84,
       1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    70,     8,     9,     1,    57,    67,    23,
       5,     6,    44,    45,    71,    72,    73,    75,    79,     8,
      45,    45,    11,    60,    77,    45,    76,     1,     6,    10,
      12,    45,    55,     1,    15,    56,     1,    21,    22,    64,
       6,    75,    11,    45,    68,    60,    63,    12,    83,    17,
      83,    16,    54,    45,    74,    13,    80,    11,    76,    59,
      60,    61,    16,    11,    81,    82,    83,    12,    18,    74,
      14,    82,    76
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    49,    50,    50,    51,    51,    51,    52,    52,    53,
      53,    54,    54,    55,    55,    55,    56,    56,    57,    58,
      59,    59,    60,    61,    61,    62,    62,    62,    62,    63,
      63,    64,    64,    64,    65,    65,    65,    66,    66,    66,
      67,    67,    68,    68,    69,    69,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    70,    70,    70,    71,
      71,    71,    72,    72,    73,    74,    75,    75,    76,    77,
      77,    78,    78,    78,    78,    78,    78,    78,    79,    79,
      79,    80,    80,    81,    81,    82,    83,    83,    83,    83,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     3,     1,     2,     2,     3,     3,     3,
       3,     1,     3,     1,     2,     3,     3,     2,     3,     2,
       1,     1,     7,     1,     3,     1,     4,     4,     3,     1,
       3,     1,     1,     1,     5,     2,     1,     1,     3,     3,
       3,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     5,     3,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     0,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* dlgs: streams DOT STOP  */
#line 307 "gestru.y"
                        {
			ystrms=(STRMTY **)0;
                        if (itsok==true) {
			  ystrms=(yyvsp[-2].strms);
                          YYACCEPT;
			  }
                        else {
			  (yyvsp[-2].strms)=freestreams((yyvsp[-2].strms));
                          YYABORT;
			  }
			}
#line 1613 "gestru.c"
    break;

  case 3: /* dlgs: error DOT STOP  */
#line 319 "gestru.y"
                        {
			(void) yyerror("Fatal error stop");
			ystrms=(STRMTY **)0;
			YYABORT;
			}
#line 1623 "gestru.c"
    break;

  case 4: /* streams: stream  */
#line 327 "gestru.y"
                        {
			(yyval.strms)=addstream((STRMTY **)0,(yyvsp[0].strm));
			}
#line 1631 "gestru.c"
    break;

  case 5: /* streams: streams stream  */
#line 331 "gestru.y"
                        {
			(yyval.strms)=(yyvsp[-1].strms);
			if ((yyvsp[0].strm)!=(STRMTY *)0)
			  (yyval.strms)=addstream((yyvsp[-1].strms),(yyvsp[0].strm));
			}
#line 1641 "gestru.c"
    break;

  case 6: /* streams: streams error  */
#line 337 "gestru.y"
                        {
			(void) yyerror("Fatal streams error");
			(yyval.strms)=freestreams((yyvsp[-1].strms));
			itsok=false;
			}
#line 1651 "gestru.c"
    break;

  case 7: /* stream: network infos SEMICOL  */
#line 345 "gestru.y"
                        {
		        (yyval.strm)=(yyvsp[-2].strm);
			if ((yyvsp[-2].strm)!=(STRMTY *)0) {
			  if ((yyvsp[-1].dlgs)!=(DLGTYP **)0)
			    (yyvsp[-2].strm)->data=(yyvsp[-1].dlgs);	
			  else
			    itsok=false;
			  }
			else {
			  if ((yyvsp[-1].dlgs)!=(DLGTYP **)0)
			    (yyvsp[-1].dlgs)=freedlgs((yyvsp[-1].dlgs));
			  itsok=false;
			  }
			}
#line 1670 "gestru.c"
    break;

  case 8: /* stream: network error SEMICOL  */
#line 360 "gestru.y"
                        {
			(void) yyerror("Fatal Error Parsing stream data");
			(yyval.strm)=tru_freestrm((yyvsp[-2].strm));
			}
#line 1679 "gestru.c"
    break;

  case 9: /* network: ipv4 SLASH INTEGER  */
#line 367 "gestru.y"
                        {
			(yyval.strm)=mkipmask((yyvsp[-2].string),(yyvsp[0].integer),32);
			}
#line 1687 "gestru.c"
    break;

  case 10: /* network: ipv6 SLASH INTEGER  */
#line 371 "gestru.y"
                        {
			(yyval.strm)=mkipmask((yyvsp[-2].string),(yyvsp[0].integer),128);
			}
#line 1695 "gestru.c"
    break;

  case 11: /* infos: info  */
#line 378 "gestru.y"
                        {
			if ((yyvsp[0].dlg)!=(DLGTYP *)0) 
			  (yyval.dlgs)=(DLGTYP **)vec_addlstlst((void **)0,(void *)(yyvsp[0].dlg));
			}
#line 1704 "gestru.c"
    break;

  case 12: /* infos: infos COMMA info  */
#line 383 "gestru.y"
                        {
			if ((yyvsp[-2].dlg)!=(DLGTYP *)0) 
			  (yyval.dlgs)=(DLGTYP **)vec_addlstlst((void **)(yyvsp[-2].dlgs),(void *)(yyvsp[0].dlg));
			}
#line 1713 "gestru.c"
    break;

  case 13: /* info: data  */
#line 390 "gestru.y"
                        {
			if ((yyvsp[0].dlg)!=(DLGTYP *)0) 
			  (void) asprintf(&((yyvsp[0].dlg)->orig),"%s","");
			(yyval.dlg)=(yyvsp[0].dlg);
			}
#line 1723 "gestru.c"
    break;

  case 14: /* info: from data  */
#line 396 "gestru.y"
                        {
			if ((yyvsp[0].dlg)!=(DLGTYP *)0) 
			  (yyvsp[0].dlg)->orig=(yyvsp[-1].string);
			(yyval.dlg)=(yyvsp[0].dlg);
			}
#line 1733 "gestru.c"
    break;

  case 15: /* info: from datetime capinfo  */
#line 402 "gestru.y"
                        {
			(yyval.dlg)=(DLGTYP *)0;
			if ((yyvsp[0].dlg)!=(DLGTYP *)0) {
			  (yyval.dlg)=(DLGTYP *)calloc(1,sizeof(DLGTYP));
			  (yyval.dlg)->orig=(yyvsp[-2].string);
			  if ((yyvsp[-1].strtime)!=(char *)0) {
			    (yyval.dlg)->flgt=atol((yyvsp[-1].strtime));
			    (void) free((yyvsp[-1].strtime));
			    }
			  (yyval.dlg)->flgdata=false;
			  (yyval.dlg)->frwdata.frw=(yyvsp[0].dlgs);
			  }
			}
#line 1751 "gestru.c"
    break;

  case 16: /* capinfo: CURLEFT infos CURIGHT  */
#line 418 "gestru.y"
                        {
			(yyval.dlg)=(yyvsp[-1].dlg);
			}
#line 1759 "gestru.c"
    break;

  case 17: /* capinfo: error CURIGHT  */
#line 422 "gestru.y"
                        {
			(yyval.dlg)=(DLGTYP *)0;
			}
#line 1767 "gestru.c"
    break;

  case 18: /* data: datetime STATUS status  */
#line 428 "gestru.y"
                        {
			(yyval.dlg)=(DLGTYP *)calloc(1,sizeof(DLGTYP));
			if ((yyvsp[-2].strtime)!=(char *)0) {
			  (yyval.dlg)->flgt=atol((yyvsp[-2].strtime));
			  (void) free((yyvsp[-2].strtime));
			  }
			(yyval.dlg)->flgdata=true;
			(yyval.dlg)->frwdata.status=(yyvsp[0].integer);
			}
#line 1781 "gestru.c"
    break;

  case 19: /* from: FROM origine  */
#line 440 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			}
#line 1789 "gestru.c"
    break;

  case 20: /* ip: ipv4  */
#line 446 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			}
#line 1797 "gestru.c"
    break;

  case 21: /* ip: ipv6  */
#line 450 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			}
#line 1805 "gestru.c"
    break;

  case 22: /* ipv4: byte DOT byte DOT byte DOT byte  */
#line 456 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%ld.%ld.%ld.%ld",
				(yyvsp[-6].integer),(yyvsp[-4].integer),(yyvsp[-2].integer),(yyvsp[0].integer));
			}
#line 1814 "gestru.c"
    break;

  case 23: /* ipv6: numipv6  */
#line 463 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			if ((yyvsp[0].string)!=(char *)0) {
			  (void) asprintf(&((yyval.string)),"ipv6:%s",(yyvsp[0].string));
			  (void) free((yyvsp[0].string));
			  }
			}
#line 1826 "gestru.c"
    break;

  case 24: /* ipv6: IPV6 COLON numipv6  */
#line 471 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			if ((yyvsp[0].string)!=(char *)0) {
			  (void) asprintf(&((yyval.string)),"%s:%s",STRIPV6,(yyvsp[0].string));
			  (void) free((yyvsp[0].string));
			  }
			}
#line 1838 "gestru.c"
    break;

  case 25: /* numipv6: pureipv6  */
#line 481 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			}
#line 1846 "gestru.c"
    break;

  case 26: /* numipv6: pureipv6 COLON COLON pureipv6  */
#line 485 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s::%s",(yyvsp[-3].string),(yyvsp[0].string));
			(void) free((yyvsp[-3].string));
			(void) free((yyvsp[0].string));
			}
#line 1856 "gestru.c"
    break;

  case 27: /* numipv6: pureipv6 COLON COLON ipv4  */
#line 491 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s::%s",(yyvsp[-3].string),(yyvsp[0].string));
			(void) free((yyvsp[-3].string));
			(void) free((yyvsp[0].string));
			}
#line 1866 "gestru.c"
    break;

  case 28: /* numipv6: pureipv6 COLON ipv4  */
#line 497 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s::%s",(yyvsp[-2].string),(yyvsp[0].string));
			(void) free((yyvsp[-2].string));
			(void) free((yyvsp[0].string));
			}
#line 1876 "gestru.c"
    break;

  case 29: /* pureipv6: hexa  */
#line 505 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			}
#line 1884 "gestru.c"
    break;

  case 30: /* pureipv6: pureipv6 COLON hexa  */
#line 509 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s:%s",(yyvsp[-2].string),(yyvsp[0].string));
			(void) free((yyvsp[-2].string));
			(void) free((yyvsp[0].string));
			}
#line 1894 "gestru.c"
    break;

  case 31: /* status: BAN  */
#line 517 "gestru.y"
                        {
			(yyval.integer)=BANBAN;
			}
#line 1902 "gestru.c"
    break;

  case 32: /* status: STD  */
#line 521 "gestru.y"
                        {
			(yyval.integer)=BANSTD;
			}
#line 1910 "gestru.c"
    break;

  case 33: /* status: error  */
#line 525 "gestru.y"
                        {
			(void) yyerror("Status can be one of ("STRBAN","STRSTD")");
			(yyval.integer)=BANSTD;
			}
#line 1919 "gestru.c"
    break;

  case 34: /* origine: domains SLASH BRKLEFT ip BRKRIGHT  */
#line 532 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s/[%s]",(yyvsp[-4].string),(yyvsp[-1].string));
			(void) free((yyvsp[-4].string));
			(void) free((yyvsp[-1].string));
			}
#line 1929 "gestru.c"
    break;

  case 35: /* origine: domains error  */
#line 538 "gestru.y"
                        {
			(yyval.string)=(char *)0;
			(void) free((yyvsp[-1].string));
			}
#line 1938 "gestru.c"
    break;

  case 36: /* origine: error  */
#line 543 "gestru.y"
                        {
			(yyval.string)=(char *)0;
			}
#line 1946 "gestru.c"
    break;

  case 37: /* domains: word  */
#line 549 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			}
#line 1954 "gestru.c"
    break;

  case 38: /* domains: domains DOT word  */
#line 553 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s.%s",(yyvsp[-2].string),(yyvsp[0].string));
			(void) free((yyvsp[-2].string));
			(void) free((yyvsp[0].string));
			}
#line 1964 "gestru.c"
    break;

  case 39: /* domains: domains MINUS word  */
#line 559 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s-%s",(yyvsp[-2].string),(yyvsp[0].string));
			(void) free((yyvsp[-2].string));
			(void) free((yyvsp[0].string));
			}
#line 1974 "gestru.c"
    break;

  case 40: /* datetime: days COMMA cachet  */
#line 567 "gestru.y"
                        {
			(yyval.strtime)=(yyvsp[0].strtime);
			}
#line 1982 "gestru.c"
    break;

  case 41: /* datetime: cachet  */
#line 571 "gestru.y"
                        {
			(yyval.strtime)=(yyvsp[0].strtime);
			}
#line 1990 "gestru.c"
    break;

  case 42: /* cachet: date time  */
#line 577 "gestru.y"
                        {
		        (yyvsp[-1].integer)+=(yyvsp[0].integer);
			(void) asprintf(&((yyval.strtime)),"%ld",(yyvsp[-1].integer));
			}
#line 1999 "gestru.c"
    break;

  case 43: /* cachet: date  */
#line 582 "gestru.y"
                        {
			(void) asprintf(&((yyval.strtime)),"%ld",(yyvsp[0].integer));
			}
#line 2007 "gestru.c"
    break;

  case 44: /* date: INTEGER months INTEGER  */
#line 588 "gestru.y"
                        {
			struct tm timing;

			(void) memset(&timing,'\000',sizeof(timing));
			timing.tm_mday=(yyvsp[-2].integer);
			timing.tm_mon=(yyvsp[-1].integer);
	 		if ((yyvsp[0].integer)<100)
			  (yyvsp[0].integer)+=2000;
			timing.tm_year=(yyvsp[0].integer)-1900;
			(yyval.time)=timegm(&timing);
			}
#line 2023 "gestru.c"
    break;

  case 45: /* date: error  */
#line 600 "gestru.y"
                        {
			(yyval.time)=time((time_t *)0);
			}
#line 2031 "gestru.c"
    break;

  case 46: /* months: JAN  */
#line 606 "gestru.y"
                        {
			(yyval.integer)=0;
			}
#line 2039 "gestru.c"
    break;

  case 47: /* months: FEB  */
#line 610 "gestru.y"
                        {
			(yyval.integer)=1;
			}
#line 2047 "gestru.c"
    break;

  case 48: /* months: MAR  */
#line 614 "gestru.y"
                        {
			(yyval.integer)=2;
			}
#line 2055 "gestru.c"
    break;

  case 49: /* months: APR  */
#line 618 "gestru.y"
                        {
			(yyval.integer)=3;
			}
#line 2063 "gestru.c"
    break;

  case 50: /* months: MAY  */
#line 622 "gestru.y"
                        {
			(yyval.integer)=4;
			}
#line 2071 "gestru.c"
    break;

  case 51: /* months: JUN  */
#line 626 "gestru.y"
                        {
			(yyval.integer)=5;
			}
#line 2079 "gestru.c"
    break;

  case 52: /* months: JUL  */
#line 630 "gestru.y"
                        {
			(yyval.integer)=6;
			}
#line 2087 "gestru.c"
    break;

  case 53: /* months: AUG  */
#line 634 "gestru.y"
                        {
			(yyval.integer)=7;
			}
#line 2095 "gestru.c"
    break;

  case 54: /* months: SEP  */
#line 638 "gestru.y"
                        {
			(yyval.integer)=8;
			}
#line 2103 "gestru.c"
    break;

  case 55: /* months: OCT  */
#line 642 "gestru.y"
                        {
			(yyval.integer)=9;
			}
#line 2111 "gestru.c"
    break;

  case 56: /* months: NOV  */
#line 646 "gestru.y"
                        {
			(yyval.integer)=10;
			}
#line 2119 "gestru.c"
    break;

  case 57: /* months: DEC  */
#line 650 "gestru.y"
                        {
			(yyval.integer)=11;
			}
#line 2127 "gestru.c"
    break;

  case 58: /* months: error  */
#line 654 "gestru.y"
                        {
			(yyval.integer)=0;
			}
#line 2135 "gestru.c"
    break;

  case 59: /* time: hours zone  */
#line 660 "gestru.y"
                        {
			(yyval.time)=(yyvsp[-1].time)-(yyvsp[0].time);
			}
#line 2143 "gestru.c"
    break;

  case 60: /* time: hours  */
#line 664 "gestru.y"
                        {
			(yyval.time)=(yyvsp[0].time);
			}
#line 2151 "gestru.c"
    break;

  case 61: /* time: zone  */
#line 668 "gestru.y"
                        {
			(yyval.time)=-(yyvsp[0].time);
			}
#line 2159 "gestru.c"
    break;

  case 62: /* hours: hour COLON sixty COLON sixty  */
#line 674 "gestru.y"
                        {
			(yyval.time)=((((yyvsp[-4].time)*60)+((yyvsp[-2].time)))*60)+(yyvsp[0].time);
			}
#line 2167 "gestru.c"
    break;

  case 63: /* hours: hour COLON sixty  */
#line 678 "gestru.y"
                        {
			(yyval.time)=(((yyvsp[-2].time)*60)+((yyvsp[0].time)))*60;
			}
#line 2175 "gestru.c"
    break;

  case 64: /* hour: INTEGER  */
#line 684 "gestru.y"
                        {
			(yyval.time)=(yyvsp[0].integer);
			if ((yyvsp[0].integer)>24) {
			  (void) yyerror("Unexpected value (above 24 Hour)");
			  (yyval.time)=0;
			  } 
			}
#line 2187 "gestru.c"
    break;

  case 65: /* sixty: INTEGER  */
#line 694 "gestru.y"
                        {
			(yyval.time)=(yyvsp[0].integer);
			if ((yyvsp[0].integer)>60) {
			  (void) yyerror("Unexpected value (above 60)");
			  (yyval.time)=0;
			  } 
			}
#line 2199 "gestru.c"
    break;

  case 66: /* zone: sign INTEGER optime  */
#line 704 "gestru.y"
                        {
			(yyval.time)=(((yyvsp[-1].integer)/100)*3600)+(((yyvsp[-1].integer)%100)*60);
			(yyval.time)*=(yyvsp[-2].integer);
			}
#line 2208 "gestru.c"
    break;

  case 67: /* zone: WORD  */
#line 709 "gestru.y"
                        {
			static struct {
				char *zname;
				int diff;
				}tznom[]={
					  {"UTC",-0},
					  {"Z",-0},
					  {"GMT",-0},
					  {"EST",-5},
					  {"EDT",-4},
					  {"CST",-6},
					  {"CDT",-5},
					  {"MST",-7},
					  {"MDT",-6},
					  {"PST",-8},
					  {"PDT",-7},
					  {"AKST",-9},
					  {"AKDT",-8},
					  {"HST",-10},
					  {"HST",-10},
					  {"BST",+1},
					  {"CET",+1},
					  {"CST",+2},
					  {(char *)0,0}
					  };
			int i;

			(yyval.time)=0;
			for (i=0;tznom[i].zname!=(char *)0;i++) {
			  if (strcasecmp(tznom[i].zname,(yyvsp[0].word))==0) {
			    (yyval.time)=tznom[i].diff*3600;
			    break;
			    }
			  }	
			(void) free((yyvsp[0].word));
			}
#line 2249 "gestru.c"
    break;

  case 68: /* byte: INTEGER  */
#line 748 "gestru.y"
                        {
			(yyval.integer)=(yyvsp[0].integer);
			if ((yyvsp[0].integer)>255) {
			  (void) yyerror("Unexpected value (above 255)");
			  (yyval.integer)=0;
			  } 
			}
#line 2261 "gestru.c"
    break;

  case 69: /* hexa: INTEGER  */
#line 758 "gestru.y"
                        {
			if ((yyvsp[0].integer)>65535) {
			  (void) yyerror("Unexpected value (above 'FFFF')");
			  (yyvsp[0].integer)=0;
			  } 
			(yyval.integer)=(yyvsp[0].integer);
			(void) asprintf(&((yyval.string)),"%04ld",(yyvsp[0].integer));
			}
#line 2274 "gestru.c"
    break;

  case 70: /* hexa: HEXA  */
#line 767 "gestru.y"
                        {
			if ((yyvsp[0].integer)>65535) {
			  (void) yyerror("Unexpected value (above 'FFFF')");
			  (yyvsp[0].integer)=0;
			  } 
			(yyval.integer)=(yyvsp[0].integer);
			(void) asprintf(&((yyval.string)),"%04lx",(yyvsp[0].integer));
			}
#line 2287 "gestru.c"
    break;

  case 71: /* days: SUN  */
#line 778 "gestru.y"
                        {
			(yyval.integer)=0;
			}
#line 2295 "gestru.c"
    break;

  case 72: /* days: MON  */
#line 782 "gestru.y"
                        {
			(yyval.integer)=1;
			}
#line 2303 "gestru.c"
    break;

  case 73: /* days: TUE  */
#line 786 "gestru.y"
                        {
			(yyval.integer)=2;
			}
#line 2311 "gestru.c"
    break;

  case 74: /* days: WED  */
#line 790 "gestru.y"
                        {
			(yyval.integer)=3;
			}
#line 2319 "gestru.c"
    break;

  case 75: /* days: THU  */
#line 794 "gestru.y"
                        {
			(yyval.integer)=4;
			}
#line 2327 "gestru.c"
    break;

  case 76: /* days: FRI  */
#line 798 "gestru.y"
                        {
			(yyval.integer)=5;
			}
#line 2335 "gestru.c"
    break;

  case 77: /* days: SAT  */
#line 802 "gestru.y"
                        {
			(yyval.integer)=6;
			}
#line 2343 "gestru.c"
    break;

  case 78: /* sign: MINUS  */
#line 808 "gestru.y"
                        {
			(yyval.integer)=-1;
			}
#line 2351 "gestru.c"
    break;

  case 79: /* sign: PLUS  */
#line 812 "gestru.y"
                        {
			(yyval.integer)=+1;
			}
#line 2359 "gestru.c"
    break;

  case 80: /* sign: PLUS MINUS  */
#line 816 "gestru.y"
                        {
			(yyval.integer)=+1;
			}
#line 2367 "gestru.c"
    break;

  case 85: /* comment: word  */
#line 831 "gestru.y"
                        {
			(void) free((yyvsp[0].word));
			(yyval.word)=(char *)0;
			}
#line 2376 "gestru.c"
    break;

  case 86: /* word: INTEGER  */
#line 838 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%ld",(yyvsp[0].integer));
			}
#line 2384 "gestru.c"
    break;

  case 87: /* word: HEXA  */
#line 842 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%lx",(yyvsp[0].integer));
			}
#line 2392 "gestru.c"
    break;

  case 88: /* word: keyword  */
#line 846 "gestru.y"
                        {
			(void) asprintf(&((yyval.string)),"%s",ykeyword);
			}
#line 2400 "gestru.c"
    break;

  case 89: /* word: WORD  */
#line 850 "gestru.y"
                        {
			(yyval.string)=(yyvsp[0].string);
			}
#line 2408 "gestru.c"
    break;


#line 2412 "gestru.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 880 "gestru.y"

#include	<memory.h>
#include	<ctype.h>
#include	<errno.h>
/*

*/
/************************************************/
/*						*/
/*	Procedure to really clean the YACC	*/
/*	satructure.				*/
/*						*/
/************************************************/
static void cleanyyparse()

{
#ifdef	YYINITSTACKSIZE
#if	YYPATCH >= 20100216
/*procedure already included byacc-1.9		*/
#else
/*to free yyparse dynamically allocated memory	*/
if (yyvs!=(YYSTYPE *)0) {
  (void) free(yyvs);
  yyvs=(YYSTYPE *)0;
  }
if (yyss!=(short *)0) {
  (void) free(yyss);
  yyss=(short *)0;
  }
yystacksize=0;
#endif
#endif
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to report a parsing error	*/
/*	debugging mode only.			*/
/*						*/
/************************************************/
static void yyerror(char *info)

{
int dbg;

dbg=0;	/*0 Trusted/Banned streams parsing check*/
if ((clm_foreground==true)||(debug>=dbg)) {
  int i;
  char crlf[3];
  char lasttoken[50];

  (void) strcpy(crlf,"");
  (void) strcpy(lasttoken,"");
  if (strcmp(info,"syntax error")==0)
    (void) sprintf(lasttoken," (last token found='%d')",lastcode);
  for (i=0;lines[curline][i]!='\000';i++)
    if (isspace(lines[curline][i])!=false)
      lines[curline][i]=' ';
  if (currow>=strlen(lines[curline]))
    (void) strcpy(crlf," ");
  (void) clm_alert(dbg,"% 6d %.*s",curline+1,currow+2,lines[curline]);
  (void) clm_alert(dbg,"%*s %*s%s",6,"",currow+1,"^",info);
  }
nbrerr++;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the punct char	*/
/*	value.					*/ 	
/*						*/
/************************************************/
static int punctchar(char c)

{
int code;

code=PUNCT;
switch (c) {
  case ':'	:
    code=COLON;
    break;
  case ';'	:
    code=SEMICOL;
    break;
  case ','	:
    code=COMMA;
    break;
  case '.'	:
    code=DOT;
    break;
  case '+'	:
    code=PLUS;
    break;
  case '-'	:
    code=MINUS;
    break;
  case '='	:
    code=EQUAL;
    break;
  case '/'	:
    code=SLASH;
    break;
  case '['	:
    code=BRKLEFT;
    break;
  case ']'	:
    code=BRKRIGHT;
    break;
  case '('	:
    code=PARLEFT;
    break;
  case ')'	:
    code=PARRIGHT;
    break;
  case '{'	:
    code=CURLEFT;
    break;
  case '}'	:
    code=CURIGHT;
    break;
  default	:
    code=PUNCT;
    break;
  }
return code;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the token value 	*/
/*	from a string				*/
/*						*/
/************************************************/
static int tokenfromstr(char *strtoken,int *disp)

{
/*	Token list				*/
static struct	{
	int code;
	char *string;
	}vocable[]={/*MUST in length order	*/
		   {STD,	STRSTD},
		   {STATUS,	STRSTA},
		   {BAN,	STRBAN},
		   {FROM,	STRFRM},
		   {IPV6,	STRIPV6},
		   {MON,"Mon"},{TUE,"Tue"},{WED,"Wed"},{THU,"Thu"},
		   {FRI,"Fri"},{SAT,"Sat"},{SUN,"Sun"},
		   {JAN,"Jan"},{FEB,"Feb"},{MAR,"Mar"},{APR,"Apr"},
		   {MAY,"May"},{JUN,"Jun"},{JUL,"Jul"},{AUG,"Aug"},
		   {SEP,"Sep"},{OCT,"Oct"},{NOV,"Nov"},{DEC,"Dec"},
		   {WORD,(char *)0}
		   };

int token;
int i;

*disp=0;
token=WORD;
for (i=0;vocable[i].string!=(char *)0;i++) {
  *disp=strlen(vocable[i].string);
  if (strncasecmp(vocable[i].string,strtoken,*disp)==0) {
    ykeyword=vocable[i].string;
    token=vocable[i].code;
    break;
    }
  }
return token;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to backspace in the header	*/
/*	the data-header				*/
/*						*/
/************************************************/
static void backspace()

{
numline=curline;
numrow=currow;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a string on a line	*/
/*						*/
/************************************************/
static char *getstring()

{
#define STRINC  20

char c;
char *strloc;
int locnumline;
int locnumrow;

locnumline=numline;
locnumrow=numrow;
strloc=(char *)calloc(1,STRINC+5);
while ((c=getnextchar())!=EOF) {
  int bspace;
  char ajout[2];

  bspace=false;
  if ((strlen(strloc)%STRINC)==0) {
    strloc=(char *)realloc(strloc,(((strlen(strloc)/STRINC)+1)*STRINC)+5);
    }
  bspace=((strlen(strloc)>1)&&(strloc[strlen(strloc)]=='\\'));
  if ((c=='\n')&&(bspace==false)) {
    (void) free(strloc);
    strloc=(char *)0;
    numline=locnumline;
    numrow=locnumrow;
    break;
    }
  if ((c=='\"')&&(bspace==false))
    break;
  ajout[0]=c;
  (void) strncat(strloc,ajout,1);
  }
return strloc;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get/recognise a lexical	*/
/*	input.					*/
/*						*/
/************************************************/
static int yylex()

{
#define MXINFO	200

int found;
int c;
int proceed;
int phase;
int disp;
int numerique;
char info[MXINFO];

found=STOP;
phase=0;
proceed=true;
disp=0;
numerique=false;
(void) memset(info,'\000',sizeof(info));
c=skipblank();
if (c==EOF) {
  if (cptstop>0) {
    (void) siglongjmp(manystop,1);
    }
  cptstop++;
  return STOP;
  }
while (proceed==true) {
  switch (phase) {
    case     0	:	/*looking for strings	*/
      if (c=='\"') {
        if ((yylval.string=getstring())!=(char *)0) {
	  found=STRING;
	  proceed=false;
	  }
	}
      break;
    case     1	:	/* looking for punct	*/
      if (isalnum(c)==false) {
        found=punctchar(c);
	yylval.punct=(char)c;
	proceed=false;
	}
      break;
    case     2	:	/* looking for keyword	*/
      if ((found=tokenfromstr(lines[numline]+(numrow-1),&disp))!=WORD) {
	char *ptr;

	ptr=lines[numline]+(numrow-1)+disp;
	if (isalnum(*ptr)==false) {
	  numrow+=(disp-1);
	  proceed=false;
	  }
	}
      break;
    case     3	:	/*checking if word could be numeric	*/
      if (isdigit(c)!=false) 
	numerique=true;
      break;
    case     4	:	/*extracting word			*/
      {
      int extract;
      unsigned int inx;

      extract=true;
      inx=0;
      while (extract==true) {
        info[inx++]=c;
        if ((c=getnextchar())==EOF) {
          found=STOP;
	  if (cptstop>0)
	    (void) siglongjmp(manystop,1);
	  cptstop++;
	  extract=false;
	  break;
          }
        if (inx>=sizeof(info))
          extract=false;
        if (extract==false)
	  break;
        extract=(isalnum(c)!=false);
	}
      (void) backspace();
      }
      break;
    case     5	:	/* Is it a pure integer	*/
      if (numerique==true) {
	int i;

	for (i=1;info[i]!='\000';i++) {
	  if (isdigit(info[i])!=false)
	    continue;
	  numerique=false;
	  break;
	  }
	if (numerique==true) {
          yylval.integer=atol(info);
          found=INTEGER;
      	  proceed=false;
	  }
	}
      break;
    case     6	:	/*Is it an exhadecimal	*/
      if (strlen(info)>0) {
	int hexa;
	int i;

	hexa=true;
	for (i=0;info[i]!='\000';i++) {
	  if (isxdigit(info[i])!=false)
	    continue;
	  hexa=false;
	  break;
	  }
	if (hexa==true) {
	  yylval.integer=strtol(info,(char **)0,16);
          found=HEXA;
      	  proceed=false;
	  }
	}
      break;
    default	:	/*safe guard			*/
      yylval.word=strdup(info);
      found=WORD;
      proceed=false;
      break;
    }
  phase++;
  }
#ifdef DEBUG
if (yydebug>0) {
  /*synchronizing yydebug output	*/
  (void) fflush(stdout);
  (void) fflush(stderr);
  }
#endif
lastcode=found;
(void) clm_alert(11,"return token (value='%d')",found);
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to parse an return a stream	*/
/*						*/
/************************************************/
static STRMTY **parsestream(char **trustlst)

{
STRMTY **parsed;
int verybad;

parsed=(STRMTY **)0;
verybad=false;
cptstop=0;
lines=trustlst;
numline=0;
numrow=0;
itsok=true;
nbrerr=0;
#ifdef DEBUG
if (debug>11)	/*debugging all yacc analyze	*/
  yydebug=1;
#endif
if (sigsetjmp(manystop,true)==0) 
  verybad=yyparse(); 
else 
  verybad=true;
parsed=ystrms;
ystrms=(STRMTY **)0;
(void) cleanyyparse();
if (verybad==true) 
  parsed=freestreams(parsed); 
return parsed;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to look at trusted data stream*/
/*	information and build sequence.		*/
/*						*/
/************************************************/
TRUTYP *tru_parsetrust(char *peername,char *peerip,char **trustlst)

{
#define	OPPA	"gestru.y:tru_parsetrust,"

TRUTYP *trust;
STRMTY **parsed;
int phase;
int proceed;

trust=(TRUTYP *)0;
parsed=(STRMTY **)0;
phase=0;
proceed=true;
while (proceed==true) {
  switch (phase) {
    case 0	:	/*open Garbage Collector*/
      break;
    case 1	:	/*parsing under GC	*/
      if ((parsed=parsestream(trustlst))==(STRMTY **)0)
	phase++;	/*no need to duplicat	*/
      break;
    case 2	:	/*dup stream without GC	*/
      if (parsed!=(STRMTY **)0)	{/*always	*/
	STRMTY **clone;
	int i;

	clone=(STRMTY **)0;
  	for (i=0;parsed[i]!=(STRMTY *)0;i++) {
    	  STRMTY *loc;

    	  loc=tru_dupstrm(parsed[i]);
          clone=(STRMTY **)vec_addlstlst((void **)clone,(void *)loc);
	  }
  	trust=(TRUTYP *)calloc(1,sizeof(TRUTYP));
  	trust->peername=strdup(peername);
  	trust->peerip=strdup(peerip);
  	trust->strms=clone; 
  	parsed=freestreams(parsed); 
    	}
      break;
    case 3	:	/*cleaning trash	*/
      break;
    default	:	/*SAFE Guard		*/
      proceed=false;
      break;
    }
  phase++;
  }
return trust;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free momory used by a	*/
/*	DLGTYP structure.			*/
/*	to a fresh identical structure.		*/
/*						*/
/************************************************/
DLGTYP *tru_freedlg(DLGTYP *dlg)

{
if (dlg!=(DLGTYP *)0) {
  if (dlg->flgdata==false)
    dlg->frwdata.frw=freedlgs(dlg->frwdata.frw);
  dlg->orig=clm_freestr(dlg->orig);
  (void) free(dlg);
  dlg=(DLGTYP *)0;
  }
return dlg;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate an DLGTYP struct	*/
/*	to a fresh identical structure.		*/
/*						*/
/************************************************/
DLGTYP *tru_dupdlg(DLGTYP *dlg)

{
DLGTYP *ndlg;

ndlg=(DLGTYP *)0;
if (dlg!=(DLGTYP *)0) {
  ndlg=(DLGTYP *)calloc(1,sizeof(DLGTYP));
  ndlg->orig=strdup(dlg->orig);
  ndlg->flgt=dlg->flgt;
  ndlg->flgdata=dlg->flgdata;
  if (ndlg->flgdata==true)
    ndlg->frwdata.status=dlg->frwdata.status;
  else
    ndlg->frwdata.frw=dupdlgs(dlg->frwdata.frw);
  }
return ndlg;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to locat within STRMTY struct	*/
/*	a BANNED information coming from the	*/
/*	same origin.				*/
/*						*/
/************************************************/
DLGTYP **tru_locdlg(STRMTY *strm,DLGTYP *dlg)

{
DLGTYP **spoted;

spoted=(DLGTYP **)0;
if ((strm!=(STRMTY *)0)&&(strm->data!=(DLGTYP **)0)) {
  DLGTYP **data;

  for (data=strm->data;*data!=(DLGTYP *)0;data++) {
    if (strcmp((*data)->orig,dlg->orig)==0) {
      spoted=data;
      break;
      }
    }
  }
return spoted;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to dump data within DLGTYP	*/
/*	structure.				*/
/*						*/
/************************************************/
char **tru_dumpdlgs(DLGTYP **dlgs,int tab)

{
static char *strcode[]={"UKN",STRSTD,STRBAN};

char **strdlgs;

strdlgs=(char **)0;
if (dlgs!=(DLGTYP **)0) {
  int i;

  for (i=0;dlgs[i]!=(DLGTYP *)0;i++) {
    char *str;
    char **strs;
    char sdate[100];

    str=(char *)0;
    strs=(char **)0;
    (void) strcpy(sdate,clm_ascsysstamp(dlgs[i]->flgt));
    switch (dlgs[i]->flgdata) {
      case false	:
	if ((strs=tru_dumpdlgs(dlgs[i]->frwdata.frw,tab+2))!=(char **)0) {
	  int j;

	  (void) asprintf(&str,"%*s%s %s %s",tab,"",STRFRM,dlgs[i]->orig,sdate);
          strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)str);
	  (void) asprintf(&str,"%*s{",tab+2,"");
          strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)str);
          for (j=0;strs[j]!=(char *)0;j++) {
            strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)strs[j]);
	    str=strs[j];
	    }
          (void) free(strs);
          str[strlen(str)-1]='\000';
	  (void) asprintf(&str,"%*s},",tab+2,"");
          strdlgs=(char **)vec_addlstlst((void **)strdlgs,(void *)str);
	  }
	break;
      default		:
 	if (dlgs[i]->frwdata.status>BANBAN)
	  dlgs[i]->frwdata.status=BANUKN;	
	if (strlen(dlgs[i]->orig)>0)
	  (void) asprintf(&str,"%*s%s %s %s %s %s,",
			        tab,"",STRFRM,dlgs[i]->orig,sdate,
				STRSTA,strcode[dlgs[i]->frwdata.status]);
	else
	  (void) asprintf(&str,"%*s%s %s %s,",
			        tab,"",sdate,STRSTA,strcode[dlgs[i]->frwdata.status]);
        strdlgs=(char **)vec_addlstlst((void **)strdlgs,str);
	break;
      }
    if ((dlgs[i+1]==(DLGTYP *)0)&&(str!=(char *)0)&&(strlen(str)>0))
      str[strlen(str)-1]=';';
    }
  }
return strdlgs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to duplicate an STRMTY struct	*/
/*	to a fresh identical structure.		*/
/*						*/
/************************************************/
STRMTY *tru_dupstrm(STRMTY *strm)

{
STRMTY *nstrm;

nstrm=(STRMTY *)0;
if (strm!=(STRMTY *)0) {
  nstrm=(STRMTY *)calloc(1,sizeof(STRMTY));
  nstrm->ip=strdup(strm->ip);
  nstrm->mask=strm->mask;
  nstrm->data=dupdlgs(strm->data);
  }
return nstrm;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free the memory used by	*/
/*	a STRMTY * structure			*/
/*						*/
/************************************************/
STRMTY *tru_freestrm(STRMTY *strm)

{
if (strm!=(STRMTY *)0) {
  strm->data=freedlgs(strm->data);
  strm->ip=clm_freestr(strm->ip);
  (void) free(strm);
  strm=(STRMTY *)0;
  }
return strm;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free the memory used by	*/
/*	a TRUTYP ** structure			*/
/*						*/
/************************************************/
TRUTYP *tru_freetrusts(TRUTYP *dattrusts)

{
if (dattrusts!=(TRUTYP *)0) {
  dattrusts->strms=freestreams(dattrusts->strms);
  dattrusts->peerip=clm_freestr(dattrusts->peerip);
  dattrusts->peername=clm_freestr(dattrusts->peername);
  (void) free(dattrusts);
  dattrusts=(TRUTYP *)0; 
  }
return dattrusts;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to do an ASCII dump of 	*/
/*	trust data.				*/
/*						*/
/************************************************/
char **tru_dumpstrm(char *myname,char *myip,STRMTY *strm)

{
char **strstrms;

strstrms=(char **)0;
if (strm!=(STRMTY *)0) {
  char *str;
  char **dlgs;

  (void) asprintf(&str,"#-Received by %s/[%s]",myname,myip);
  strstrms=(char **)vec_addlstlst((void **)strstrms,(void *)str);
  (void) asprintf(&str,"%s/%d",strm->ip,strm->mask);
  strstrms=(char **)vec_addlstlst((void **)strstrms,(void *)str);
  if ((dlgs=tru_dumpdlgs(strm->data,4))!=(char **)0) {
    int j;
    
    for (j=0;dlgs[j]!=(char *)0;j++) 
      strstrms=(char **)vec_addlstlst((void **)strstrms,(void *)dlgs[j]);
    (void) free(dlgs);
    }
  }
return strstrms;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to preapre ASCII conversion	*/
/*	of the stream, adding the origin.	*/
/*						*/
/************************************************/
void tru_setorigin(TRUTYP *dattrusts)

{
if (dattrusts!=(TRUTYP *)0) {
  char *origin;

  (void) asprintf(&origin,"%s/[%s]",dattrusts->peername,dattrusts->peerip);
  if (dattrusts->strms!=(STRMTY **)0) {
    STRMTY **ptr;

    for (ptr=dattrusts->strms;*ptr!=(STRMTY *)0;ptr++) {
      if ((*ptr)->data!=(DLGTYP **)0) {
	DLGTYP **dlgs;
	int count;

	dlgs=(*ptr)->data;
	count=vec_sizelstlst((void **)dlgs);
	if ((count==1)&&(strlen((*dlgs)->orig)==0)) {
	  (void) free((*dlgs)->orig);
	  (*dlgs)->orig=strdup(origin);
	  }
	else {
	  DLGTYP *dlg;

	  dlg=(DLGTYP *)calloc(1,sizeof(DLGTYP));
	  dlg->orig=strdup(origin);
	  dlg->flgt=time((time_t *)0);
	  dlg->flgdata=false;
	  dlg->frwdata.frw=dlgs;
          (*ptr)->data=(DLGTYP **)vec_addlstlst((void **)0,(void *)dlg);
	  }
	}
      }
    }
  (void) free(origin);
  }
}
